$large
Config I2cdelay = 0
Config Sda = P3.5
Config Scl = P3.7
Config Timer0 = Timer , Gate = Internal , Mode = 0            ' Konfigurowanie licznikow
Config Timer1 = Timer , Gate = Internal , Mode = 1
On Timer0 Multipl
On Timer1 Odliczaj
Load Timer0 , 200
Enable Timer0
Enable Timer1
Enable Interrupts

Declare Sub Volume
Declare Sub Up
Declare Sub Down
Declare Sub Wart
Declare Sub Zap_kor (temp1 As Byte)			'Procedura zapisu danych do ukladu korektora
Declare Sub Write_eeprom(adres As Byte , Value As Byte)   'procedura zapisu pamieci eeprom
Declare Sub Read_eeprom(adres As Byte , Value As Byte)	'procedura odczytu pamieci eeprom
Declare Sub Zapis_kor
Declare Sub Odczyt_pam
Declare Sub Setup				'procedura konfiguracji korektora

Mir Alias P3.2
Clk Alias P3.1
Ab Alias P3.0
A1 Alias P1.2
A2 Alias P1.3
A3 Alias P1.4
A4 Alias P1.5
A5 Alias P1.6

Dim Adres As Byte
Dim Value As Byte
Dim Temp As Byte
Dim Temp1 As Byte
Dim Nr_s As Byte
Dim Pasmo (6) As Byte
Dim I As Byte
Dim Key As Byte
Dim Temp2 As Byte
Dim Temp3 As Byte
Dim Vol As Bit
Dim Setup As Bit
Dim Flaga As Bit
Dim Flaga1 As Bit
Dim V1 As Byte
Dim V2 As Byte
Dim Zn As Bit
Dim Zn1 As Bit
Dim R As Byte
Dim Temp4 As Byte
Dim Pam As Byte
Dim Licz As Byte


Pasmo(1) = 8			'domyslne parametry pasm korektora
Pasmo(2) = 8
Pasmo(3) = 8
Pasmo(4) = 8
Pasmo(5) = 8
Pasmo(6) = 32

Call Read_eeprom , 9 , Value	'odczyt parametrow korektora z pamieci eeprom
If Value <> 45 Then
  For R = 10 To 50 Step 10
   For I = 1 To 6
    Temp1 = R + I
    Value = Pasmo(i)
    Call Write_eeprom , Temp1 , Value
   Next I
  Next R
  Call Write_eeprom , 9 , 45
  Call Write_eeprom , 3 , 10
End If

Call Read_eeprom , 9 , Value
If Value = 45 Then
  Call Odczyt_pam
End If

Call Zapis_kor	
Counter1 = 4150
Licz = 0
Vol = 1
Setup = 1
Flaga = 0
Flaga1 = 0
Nr_s = 5
Reset Mir
Set Clk
Temp2 = 24
Key = 0
Reset P1.0
Reset P1.1
Set P1.7
Set P3.3
Set P3.4
Start Timer0
Waitms 250

Do                                                            ' program glowny
  If Temp2 <> 24 Then                                         ' ktory obsluguje przyciski
    If Key < 14 And Key <> 0 Then
      Key = Key - 8
      I = Key
      Call Up
    Else
      Key = Key - 16
      I = Key
      Call Down
    End If
    Temp1 = Pasmo(i)
    R = Pam + I
    Value = Temp1
    Call Write_eeprom , R , Value
    Call Zap_kor(temp1)
    Key = 0
    Temp2 = 24
    Waitms 250
  End If
  If Vol = 0 Then
    Call Volume
  End If
  If Setup = 0 Then
    Call Setup
  End If
Loop
End

Multipl:                                                      ' Procedura multipleksowania wyswietlacza
  Load Timer0 , 20500
  Start Timer0
  Reset A1
  Reset A2
  Reset A3
  Reset A4
  Reset A5
  Incr Nr_s
  If Nr_s = 6 Then
    Nr_s = 1
  End If
  Call Wart
  Delay
  Select Case Nr_s
  Case 1:
     Set A1
     Vol = P1.7
  Case 2:
     Set A2
     Setup = P1.7
  Case 3:
     Set A3
  Case 4:
     Set A4
  Case 5:
     Set A5
  End Select
  Temp2 = P3 And &B00011000
  Key = Temp2 + Nr_s
Return

Sub Wart                                                      ' podprogram ustawiania slupka wyswietlaczy
 If Flaga1 = 1 Then
  Temp4 = Pam / 10
  If Temp4 = Nr_s Then
   $asm
    setb ab
    clr mir
    setb mir
    setb clk
    clr clk
   $end Asm
  Else
   $asm
    clr mir
    setb mir
   $end Asm
  End If
 Else
  If Flaga = 0 Then
   Temp3 = Pasmo(nr_s)
   $asm
    Mov a,{temp3}
    setb ab
    clr mir
    setb mir
    Licz:
      setb clk
      clr clk
      clr ab
      Dec a
      jnz licz
   $end Asm
  Else
   V2 = Pasmo(6)
   Shift V2 , Right , 3
   V2 = 5 - V2
   If V2 >= Nr_s Then
    $asm
      setb ab
      clr mir
      setb mir
      setb clk
      clr clk
    $end Asm
   Else
    $asm
      clr mir
      setb mir
    $end Asm
   End If
  End If
 End If
End Sub

Sub Zap_kor(temp1 As Byte)                                    ' zapis danych do korektora
 I2cstart
 I2cwbyte 132
 If I = 6 Then
  Temp = Temp1
  Reset Temp.7
 Else
  Temp = I - 1
  Shift Temp , Left , 4
  Set Temp.7
  If Pasmo(i) <= 8 Then
   Temp1 = 8 - Temp1
   Set Temp.3
  Else
   Temp1 = Temp1 - 8
   Reset Temp.3
  End If
  Temp = Temp + Temp1
 End If
 I2cwbyte Temp
 I2cstop
 Temp1 = 24
End Sub

Sub Up                                                        ' obsluga przyciskow up
 Incr Pasmo(i)
 If Pasmo(i) = 16 Then
  Pasmo(i) = 15
 End If
End Sub

Sub Down                                                      ' obsluga przyciskow down
 Decr Pasmo(i)
 If Pasmo(i) = 0 Then
  Pasmo(i) = 1
 End If
End Sub

Sub Setup                                                     ' obsluba przycisku mem
  If Setup = 0 Then
   Do
   Loop Until Setup = 1
  End If
  Flaga1 = 1
  Start Timer1
  Do
   Key = 0
   Temp2 = 24
   Zn1 = 0
   If Key = 9 Then
    Licz = 0
    Call Write_eeprom , 3 , 10
    Call Odczyt_pam
    Call Zapis_kor
    Zn1 = 1
   Elseif Key = 10 Then
    Licz = 0
    Call Write_eeprom , 3 , 20
    Call Odczyt_pam
    Call Zapis_kor
    Zn1 = 1
   Elseif Key = 11 Then
    Licz = 0
    Call Write_eeprom , 3 , 30
    Call Odczyt_pam
    Call Zapis_kor
    Zn1 = 1
   Elseif Key = 12 Then
    Licz = 0
    Call Write_eeprom , 3 , 40
    Call Odczyt_pam
    Call Zapis_kor
    Zn1 = 1
   Elseif Key = 13 Then
    Licz = 0
    Call Write_eeprom , 3 , 50
    Call Odczyt_pam
    Call Zapis_kor
    Zn1 = 1
   End If
   Key = 0
   Temp2 = 24
  Loop Until Zn1 = 1
  Flaga1 = 0
  Stop Timer1
  Counter1 = 4150
  Licz = 0
  Waitms 250
End Sub

Sub Volume                                                    ' obsluga przycisku vol
  Zn = 0
  Flaga = 1
  If Vol = 0 Then
   Do
   Loop Until Vol = 1
  End If
  Start Timer1
  Do
    V1 = Pasmo(6)
    Shift , V1 , Right , 3
    If Key = 9 Then
     Licz = 0
     Zn = 1
     Decr V1
     If V1 = 255 Then
      V1 = 0
     End If
    End If
    If Key = 17 Then
     Licz = 0
     Zn = 1
     Incr V1
     If V1 = 6 Then
      V1 = 5
     End If
    End If
    If Zn = 1 Then
     Shift , V1 , Left , 3
     Zn = 0
     I = 6
     Pasmo(6) = V1
     Temp1 = Pasmo(i)
     Call Zap_kor(temp1)
     R = Pam + I
     Value = Pasmo(i)
     Call Write_eeprom , R , Value
     Key = 0
     Temp2 = 24
     Waitms 250
    End If
    If Vol = 0 Then
     Flaga = 0
     Do
     Loop Until Vol = 1
    End If

  Loop Until Flaga = 0
  Stop Timer1
  Licz = 0
  Counter1 = 4150
End Sub

Sub Write_eeprom(adres As Byte , Value As Byte)               ' zapis danych do eeprom
  I2cstart
  I2cwbyte 160
  I2cwbyte Adres
  I2cwbyte Value
  I2cstop
  Waitms 15
End Sub

Sub Read_eeprom(adres As Byte , Value As Byte)                ' odczyt danych z eeprom
  I2cstart
  I2cwbyte 160
  I2cwbyte Adres
  I2cstart
  I2cwbyte 161
  I2crbyte Value , 9
  I2cstop
End Sub

Odliczaj:                                                     ' procedura odliczajaca czas bezczynnosci
  Counter1 = 4150
  If Licz = 75 Then
    Flaga = 0
    Zn1 = 1
  End If
  Incr Licz
  Start Timer1
Return

Sub Odczyt_pam                                                'procedura odczytu wszystkich danych
  Call Read_eeprom , 3 , Value                                ' odpowiedniej podpamieci
  Pam = Value
  For I = 1 To 6
    R = Pam + I
    Call Read_eeprom , R , Value
    Pasmo(i) = Value
  Next I
End Sub

Sub Zapis_kor                                                 ' procedura zapisu calej konfiguracji do korektora cyfrowego
  For I = 1 To 6
    Temp1 = Pasmo(i)
    Call Zap_kor(temp1)
  Next I
End Sub