'Dwupunktowy termometr
'Marcin Wizania

$large
Config Timer0 = Timer , Gate = Internal , Mode = 0
Config Sda = P1.1
Config Scl = P1.0
Config 1wire = P1.2

On Timer0 Multip

Declare Sub Wart
Declare Sub Pobierz
Declare Sub Obs_klaw
Declare Sub Przyciski
Declare Sub Write_eeprom(adres As Byte , Value As Byte)
Declare Sub Read_eeprom(adres As Byte , Value As Byte)
Declare Sub Odcz_temp
Declare Sub Zap_num
Declare Sub Zal_wart
Declare Sub Obsl_s1
Declare Sub Obsl_s2

Dim Nr_w As Byte
Dim Cyfr(2) As Byte
Dim Kontr As Byte
Dim I As Byte
Dim Temp1 As Byte
Dim K As Byte
Dim Temp2 As Word
Dim Key As Byte
Dim Temp(6) As Byte
Dim Ind As Byte
Dim Temp4 As Byte
Dim Il_c As Byte                                              'ilosc czujnikow
Dim Adres As Byte
Dim Value As Byte
Dim J As Byte
Dim Id(8) As Byte                                             'tablica na numer seryjny DS1820
Dim L As Byte

W1 Alias P3.0
W2 Alias P3.1
W3 Alias P3.2
W4 Alias P3.3
W5 Alias P3.4
W6 Alias P3.5
W7 Alias P3.7
Clk Alias P1.7
Ab Alias P1.6
S1 Alias P1.5
S2 Alias P1.4
S3 Alias P1.3
L_max Alias Kontr.0
L_min Alias Kontr.1
L_zew Alias Kontr.2
L_wew Alias Kontr.3
L_m1 Alias Kontr.4
L_m2 Alias Kontr.5

Set S1
Set S2
Set S3
Nr_w = 255
Kontr = 255
Temp4 = 3
Ind = 1
Reset Clk
Set Ab
Load Timer0 , 200
Enable Timer0
Enable Interrupts


Cyfr(1) = 10
Cyfr(2) = 10
Start Timer0
Temp(1) = 128                                                 'tzew
Temp(2) = 128                                                 'twew
Temp(3) = 128                                                 'tminzew
Temp(4) = 128                                                 'tminwew
Temp(5) = 128                                                 'tmaxzew
Temp(6) = 128
I = 0
Waitms 100
Call Read_eeprom , 9 , Value                                  'odczyt iliczby zarejestrowanych czujnikow

If Value > 3 Then
  Call Write_eeprom , 9 , 0
End If

If S3 = 0 Then                                                'podprogram kasowania pamieci eeprom (czujnikow)
  For J = 1 To 20
    Call Write_eeprom , J , 0
  Next J
  For J = 21 To 30
    Call Write_eeprom , J , 128
  Next J
  Cyfr(1) = 11
  Cyfr(2) = 11
  Do
  Loop
End If

Call Read_eeprom , 9 , Value                                  'odczyt ilosci czujnikow
Il_c = Value
Cyfr(1) = 10
Cyfr(2) = 10
L = 3

For J = 23 To 26                                              'odczyt zapamietach wartosci min oraz max
  Call Read_eeprom , J , Value
  Temp(l) = Value
  Incr L
Next J

If S1 = 0 Then                                                'procedura rejestracji czujnika 1
  Reset L_zew
  Bitwait S1 , Set                                            'czekaj na puszczenie przycisku
  Do
    If Il_c = 1 Or Il_c = 3 Then                              'jezeli zarejestrowany czujnik 1 to wyjdz z rejestracji
      Exit Do
    End If
    Reset L_zew
    Waitms 250
    Stop Timer0
    1wreset                                                   'odczyt numeru seryjnego czujnika
    If Err = 0 Then
      1wwrite &H33
      For J = 1 To 8
        Id(j) = 1wread()
      Next J
      Start Timer0
      Waitms 10                                               'jezeli brak bledow w odczycie numeru seryjnego
      For J = 1 To 8                                          'to zapis numerow seryjnych do eeprom
        Value = Id(j)
        Call Write_eeprom , J , Value
      Next J
      If Il_c = 0 Then
        Call Write_eeprom 9 , 1
        Il_c = 1
      End If
      If Il_c = 2 Then
        Call Write_eeprom 9 , 3
        Il_c = 3
      End If
    End If
    Stop Timer0
    1wreset
    Start Timer0
    Set L_zew
    Waitms 250
  Loop Until Err = 0                                          'Jezeli brak bledow to opuszczana jest petla do-loop
End If

If S2 = 0 Then                                                'procedura rejestracji czujnika 2
  Reset L_wew
  Bitwait S2 , Set                                            'czekaj na puszczenie przycisku
  Do                                                          'poczatek petli do-loop
    If Il_c = 2 Or Il_c = 3 Then
      Exit Do
    End If
    Reset L_wew
    Waitms 250
    Stop Timer0
    1wreset                                                   'odczyt numeru seryjnego czujnika 2
    If Err = 0 Then
      1wwrite &H33
      For J = 1 To 8
        Id(j) = 1wread()
      Next J
      Start Timer0
      Waitms 10                                               'jezeli brak bledow w odczycie numeru seryjnego
      L = 0
      For J = 10 To 17                                        'to zapis numerow seryjnych do eeprom
        Incr L
        Value = Id(l)
        Call Write_eeprom , J , Value
      Next J
      If Il_c = 0 Then
        Call Write_eeprom 9 , 2
        Il_c = 2
      End If
      If Il_c = 1 Then
        Call Write_eeprom 9 , 3
        Il_c = 3
      End If
    End If
    Stop Timer0
    1wreset
    Start Timer0
    Set L_wew
    Waitms 250
  Loop Until Err = 0                                          'Jezeli brak bledow to opuszczana jest petla do-loop
End If

If Il_c = 0 Then                                              'Jezeli brak zarejestrowanych czujnikow to sygnalizuj litera "b"
  Do
    Cyfr(1) = 10
    Cyfr(2) = 11
    Waitms 250
    Cyfr(1) = 11
    Cyfr(2) = 10
    Waitms 250
  Loop
End If

If Il_c = 2 Then                                              'ustaw odpowiednio flage l_wew w zaleznosci od ilosci czujnikow
  Reset L_wew
End If

Key = 1
Do                                                            'program glowny
  Call Przyciski                                              'procedura obslugi przyciskow
  If I = 1 Then                                               'jezeli i=1 to zmieniaj automatyczne wskazania zgodnie z tryb 1
    Waitms 500
    Key = 1
    Call Obsl_s1
    Waitms 500
  End If

  If I = 2 Then                                               'jezeli i=2 to zmieniaj automatyczne wskazania zgodnie z tryb 2                                         'procedura
    If Temp4 = 3 Then
      Key = 1
      Call Obsl_s1
    End If
    Waitms 500
    Call Obs_klaw
    Call Zal_wart
    If Temp4 = 1 Then
      Temp4 = 2
    Elseif Temp4 = 2 Then
      Temp4 = 3
    Elseif Temp4 = 3 Then
      Temp4 = 1
    End If
    Waitms 500
  End If

  If Il_c = 1 Or Il_c = 3 Then                                'odczyt temperatury oraz sprawdzenie wartosci max oraz min dla czujnika 1
    For J = 1 To 8                                            'Odczyt numeru seryjnego z eeprom
      Read_eeprom , J , Value
      Id(j) = Value
    Next J
    Call Odcz_temp
    Temp(1) = Adres
    If Temp(1) > Temp(5) Then
      Temp(5) = Temp(1)
      Value = Temp(5)
      Call Write_eeprom , 25 , Value
    End If
    If Temp(1) < Temp(3) Then
      Temp(3) = Temp(1)
      Value = Temp(3)
      Call Write_eeprom , 23 , Value
    End If
  End If
  If Il_c = 2 Or Il_c = 3 Then                                'odczyt temperatury oraz sprawdzenie wartosci max oraz min dla czujnika 1
    L = 0
    For J = 10 To 17                                          'Odczyt numeru seryjnego z eeprom
      Incr L
      Read_eeprom , J , Value
      Id(l) = Value
    Next J
    Waitms 20
    Call Odcz_temp
    Temp(2) = Adres
    If Temp(2) > Temp(6) Then
      Temp(6) = Temp(2)
      Value = Temp(6)
      Call Write_eeprom , 26 , Value
    End If
    If Temp(2) < Temp(4) Then
      Temp(4) = Temp(2)
      Value = Temp(4)
      Call Write_eeprom , 24 , Value
    End If
  End If
Loop                                                          'poniec programu glownego
End

Sub Zal_wart
  If Temp(ind) < 128 Then
    Reset L_m1
    Reset L_m2
    Adres = 128 - Temp(ind)
  Else
    Adres = Temp(ind) - 128
    Set L_m1
    Set L_m2
  End If
  Cyfr(2) = Adres / 10
  Cyfr(1) = Adres Mod 10
End Sub

Sub Zap_num                                                   'Procedura wyboru odpowiedniego czujnika
  Disable Timer0                                              'poprzez zapisanie wczesniej odczytanych
  1wreset                                                     'numerow seryjnych
  Enable Timer0
  Waitms 5
  Disable Timer0
  1wwrite &H55
  Enable Timer0
  Waitms 5
  For J = 1 To 8
    Disable Timer0
    1wwrite Id(j)
    Enable Timer0
    Waitms 5
  Next J
End Sub

Sub Odcz_temp                                                 'Procedura odczytu temperatury
  Call Zap_num                                                'Wywolanie procedury zapisu numeru seryjnego do DS1820
  Disable Timer0
  1wwrite &H44                                                'Start konwersji
  Enable Timer0
  For J = 1 To 450
    Call Przyciski
    Waitms 1
  Next I
  Call Zap_num
  Disable Timer0
  1wwrite &HBE                                                'odczyt zmierzonej temperatury
  Enable Timer0
  Waitms 5
  Disable Timer0
  Adres = 1wread()
  Value = 1wread()
  Enable Timer0
  Waitms 5
  Disable Timer0
  1wreset
  Enable Timer0
  If Value = 0 Then                                           'odpowiednie przeliczanie odczytanej temperatury
    Adres = Adres / 2                                         'wart=127 to -1 wart=128 to 0 wart=129 to 1 itd
    Adres = Adres + 128
    If Adres > 227 Then
      Adres = 227
    End If
  Else                                                        'przeliczenie ujemnej odczytanej temperatury
    Adres = 256 - Adres
    Adres = Adres / 2
    Adres = 128 - Adres
    If Adres < 29 Then
      Adres = 29
    End If
  End If
End Sub

Sub Obsl_s1                                                   'procedura obslugi klawisza S1 (wyboru czujnika)
  If Key = 1 Then
    If L_zew = 0 Then
      If Il_c = 2 Or Il_c = 3 Then
        Set L_zew
        Reset L_wew
      End If
    Else
      If Il_c = 1 Or Il_c = 3 Then
        Set L_wew
        Reset L_zew
      End If
    End If
    Waitms 20
    Call Obs_klaw
    Call Zal_wart                                             'procedura ladujaca wartosc do wyswietlenia
    Bitwait S1 , Set
    Waitms 50
    Key = 0
  End If
End Sub

Sub Obsl_s2                                                   'procedura obslugo klawisza S2 (wyboru max oraz min)
  If Key = 2 Then
    Incr Temp4
    If Temp4 = 4 Then
      Temp4 = 1
    End If
    Waitms 20
    Call Obs_klaw
    Call Zal_wart
    Bitwait S2 , Set
    Waitms 50
    Key = 0
  End If
End Sub

Sub Przyciski                                                 'glowna procedura obslugi przyciskow s1, s2,s3
  If I = 0 Then
    Call Obsl_s1
    Call Obsl_s2
  End If
  If Key = 3 Then                                             'obsluga klawisza s3 (umozliwia wybor trybu wskazac termometru oraz kasowanie temp max oraz min)
    If Ind > 2 And I = 0 Then
      If L_zew = 0 Then
        Temp(ind) = Temp(1)
        Value = Temp(ind)
        Adres = 20 + Ind
        Call Write_eeprom , Adres , Value
      Else
        Temp(ind) = Temp(2)
        Value = Temp(ind)
        Adres = 20 + Ind
        Call Write_eeprom , Adres , Value
      End If
    Else
      Incr I
      If I = 3 Then
        I = 0
        Temp4 = 3
        Call Obs_klaw
      End If
      Cyfr(1) = I
      Cyfr(2) = 11
      Wait 1
      Bitwait S3 , Set
    End If
    Waitms 20
    Call Obs_klaw
    Call Zal_wart
    Bitwait S3 , Set
    Waitms 50
    Key = 0
  End If
  Call Zal_wart
End Sub

Sub Obs_klaw                                                  'procedura zmiany zmiennej indeksowaj wzaleznosci od nacisnietego przycisku
  If Temp4 = 1 Then
    Set L_max
    Reset L_min
    If L_wew = 0 Then
      Ind = 4
    Else
      Ind = 3
    End If
  End If
  If Temp4 = 2 Then
    Set L_min
    Reset L_max
    If L_zew = 0 Then
      Ind = 5
    Else
      Ind = 6
    End If
  End If
  If Temp4 = 3 Then
    Set L_min
    Set L_max
    If L_wew = 0 Then
      Ind = 2
    Else
      Ind = 1
    End If
  End If
End Sub

Sub Pobierz                                                   'procedura pobierajaca dane do wyswietlenia z tablic znakow
  If Cyfr(k) = 1 Then
    Temp1 = Lookup(nr_w , Jeden)
  End If
  If Cyfr(k) = 2 Then
    Temp1 = Lookup(nr_w , Dwa)
  End If
  If Cyfr(k) = 3 Then
    Temp1 = Lookup(nr_w , Trzy)
  End If
  If Cyfr(k) = 4 Then
    Temp1 = Lookup(nr_w , Cztery)
  End If
  If Cyfr(k) = 5 Then
    Temp1 = Lookup(nr_w , Piec)
  End If
  If Cyfr(k) = 6 Then
    Temp1 = Lookup(nr_w , Szesc)
  End If
  If Cyfr(k) = 7 Then
    Temp1 = Lookup(nr_w , Siedem)
  End If
  If Cyfr(k) = 8 Then
    Temp1 = Lookup(nr_w , Osiem)
  End If
  If Cyfr(k) = 9 Then
    Temp1 = Lookup(nr_w , Dziewiec)
  End If
  If Cyfr(k) = 0 Then
    Temp1 = Lookup(nr_w , Zero)
  End If
  If Cyfr(k) = 10 Then
    Temp1 = Lookup(nr_w , Wygas)
  End If
  If Cyfr(k) = 11 Then
    Temp1 = Lookup(nr_w , Lit_b)
  End If
  Temp1.5 = Kontr.nr_w                                        'zaladowanie wartosci zmiennej zawierajacej dane o diodach LED
End Sub

Sub Wart                                                      'procedura wysylajaca dane do rejestrow U1, U2
  Temp2 = 0
  K = 1
  Call Pobierz                                                'pobranie znaku dla wyswietlacza 1
  Temp2.1 = Temp1.0
  Temp2.2 = Temp1.1
  Temp2.3 = Temp1.2
  Temp2.5 = Temp1.3
  Temp2.6 = Temp1.4
  Temp2.0 = Temp1.5
  K = 2
  Call Pobierz                                                'pobranie znaku dla wyswietlacza 2
  Temp2.7 = Temp1.0
  Temp2.8 = Temp1.1
  Temp2.9 = Temp1.2
  Temp2.10 = Temp1.3
  Temp2.11 = Temp1.4
  For Temp1 = 1 To 12                                         'wyslanie 12 bitow danych
    Ab = Temp2.0
    Set Clk
    Reset Clk
    Shift Temp2 , Right , 1
  Next Temp1
End Sub

Sub Write_eeprom(adres As Byte , Value As Byte)               'procedura zapisu danych do eeprom
  I2cstart
  I2cwbyte 160
  I2cwbyte Adres
  I2cwbyte Value
  I2cstop
  Waitms 15
End Sub

Sub Read_eeprom(adres As Byte , Value As Byte)                'procedura odczytu danych z eeprom
  I2cstart
  I2cwbyte 160
  I2cwbyte Adres
  I2cstart
  I2cwbyte 161
  I2crbyte Value , 9
  I2cstop
End Sub

Multip:                                                       'przerwanie od timer 0
  Stop Timer0                                                 'zadaniem tej procedury jest multipleksowanie wyswietlacza
  Load Timer0 , 9500
  Set W1
  Set W2
  Set W3
  Set W4
  Set W5
  Set W6
  Set W7
  Incr Nr_w
  If Nr_w = 7 Then
    Nr_w = 0
  End If
  Call Wart
  Select Case Nr_w                                            'wybor wiersza
    Case 0:
      Reset W1                                                'wiersz 1
    Case 1:
      Reset W2
    Case 2:
      Reset W3
    Case 3:
      Reset W4
    Case 4:
      Reset W5
    Case 5:
      Reset W6
    Case 6:
      Reset W7
  End Select
  If S1 = 0 Then                                              'obsluga przyciskow. 'w zaleznosci od nacisnietego
    Key = 1                                                   'przycisku odpowiednio ustawiana jest zmienna key
  End If
  If S2 = 0 Then
    Key = 2
  End If
  If S3 = 0 Then
    Key = 3
  End If
  Start Timer0
Return

Jeden:                                                        'tablice znakow
  Data &B00011011 , &B00010011 , &B00011011 , &B00011011 , &B00011011 , &B00011011 , &B00010001
Dwa:
  Data &B00010001 , &B00001110 , &B00011110 , &B00011101 , &B00011011 , &B00010111 , &B00000000
Trzy:
  Data &B00000000 , &B00011101 , &B00011011 , &B00011101 , &B00011110 , &B00001110 , &B00010001
Cztery:
  Data &B00011101 , &B00011001 , &B00010101 , &B00001101 , &B00000000 , &B00011101 , &B00011101
Piec:
  Data &B00000000 , &B00001111 , &B00000001 , &B00011110 , &B00011110 , &B00001110 , &B00010001
Szesc:
  Data &B00011001 , &B00010111 , &B00001111 , &B00000001 , &B00001110 , &B00001110 , &B00010001
Siedem:
  Data &B00000000 , &B00011110 , &B00011101 , &B00011011 , &B00010111 , &B00010111 , &B00010111
Osiem:
  Data &B00010001 , &B00001110 , &B00001110 , &B00010001 , &B00001110 , &B00001110 , &B00010001
Dziewiec:
  Data &B00010001 , &B00001110 , &B00001110 , &B00010000 , &B00011110 , &B00011101 , &B00010011
Zero:
  Data &B00010001 , &B00001110 , &B00001100 , &B00001010 , &B00000110 , &B00001110 , &B00010001
Lit_b:
  Data &B00001111 , &B00001111 , &B00001001 , &B00000110 , &B00001110 , &B00001110 , &B00000001
Wygas:
  Data &B00011111 , &B00011111 , &B00011111 , &B00011111 , &B00011111 , &B00011111 , &B00011111