'Samochodowy obrotomierz
'Marcin Wizania
'E-mail: mwiazani@poczta.fm

$regfile = "89c2051.dat"
$crystal = 12000000

Config Timer0 = Timer , Gate = Internal , Mode = 1
Config Timer1 = Timer , Gate = Internal , Mode = 1

Declare Sub Przel_gr1                                         'podrogramy sprawdzenia warunkow zapalenia diod grupy 1 do 5
Declare Sub Przel_gr2
Declare Sub Przel_gr3
Declare Sub Przel_gr4
Declare Sub Przel_gr5

On Timer0 Zw_licz_czasu                                       'przerwonia obslugi przpelnienia timera0
On Timer1 Obs_wysw                                            'przerwanie od timer1 obslugujace wyswietlacz led
On Int1 Pomiar                                                'przerowania obslugi pomiaru

Dim Nr_gr_led As Byte                                         'okresla numer grupy dio led
Dim Gr(5) As Byte                                             'tablica zmiennych sterujacych diodami led
Dim Wynik As Word                                             'obliczony wynik predkosci RPM
Dim Temp As Word                                              'zmienna pomocnicza do obliczen
Dim Zm_pom As Long                                            'zmienna przechowujaca ilosc zliczonych impulsow podczas jednego obrotu
Dim Zez_pom As Bit                                            'flaga zezwolenia na pomiar
Dim Pom_zak As Bit                                            'flaga informujaca o zakonczeniu pomiaru
Dim Licz_czas As Byte                                         'pomocniczy licznik czasu
Dim Br_syg As Byte                                            'zmienna licznikowa graku impulsow na wejsciu

Gr1 Alias P3.0
Gr2 Alias P3.1
Gr3 Alias P3.2
Gr4 Alias P3.4
Gr5 Alias P3.5
Jp Alias P3.7

Set Jp
Set Gr1
Set Gr2
Set Gr3
Set Gr4
Set Gr5

Nr_gr_led = 1
Set Tcon.2                                                    'przerwanie int1 reagowac bedzie na opadajace zbocze
Priority Set Int1
Priority Reset Timer0
Disable Int0
Enable Timer0
Enable Timer1
Enable Int1
Counter1 = 61800                                              'wartosc poczatkowa timera1
Start Timer1
Wynik = 0
Set Zez_pom
Reset Pom_zak
Br_syg = 0
Enable Interrupts

Do                                                            'petla glowna programu
  If Pom_zak = 1 Then                                         'jezeli pomiar zakonczony to
    Disable Timer0                                            'zablokuj timer0
    Temp = Counter0                                           'odczytaj wartosc timera0
    Zm_pom = Zm_pom + Temp                                    'dodaj ja do wartosci zmiennej zm_pom
    Temp = 60000000 / Zm_pom                                  'oblicz predkosc ze wzoru 60*1MHz/zm_pom
    If Jp = 0 Then                                            'jezeli zwora zalozona to podziel
      Temp = Temp / 2                                         'wynik przez 2 gdy na obrot przypadaja dwa zaplony
    End If
    Wynik = Temp                                              'zapiasz wynik do zmiennej wynik
    Reset Pom_zak                                             'zeruj flage zezwolenia na obliczenie predkosci
    Set Zez_pom                                               'ustaw flage zezwalajaca na pomiar
    Zm_pom = 0                                                'wyzeruj zmienne
    Licz_czas = 0
    Enable Timer0
  Else                                                        'w przeciwnym wypadku
    If Wynik > 0 And Br_syg = 65 Then                         'jezeli wynik >0 oraz wartosc br_syg=65 to
      nop
      nop
      nop
      Decr Wynik                                              'zmniejsz zmienna wyniku
    End If
  End If
Loop                                                          'koniec petli glownej programu
End

Zw_licz_czasu:                                                'przerwanie przepelnienia timera0
  Zm_pom = Zm_pom + 65536                                     'dodaj wartosc 65536 (licznik pracuje jako 16-bitowy)
  Incr Licz_czas                                              'zwieksz zmienna licz_czas
  If Licz_czas = 10 Then                                      'jezeli wartosc tej zmiennej osiagnie 10 to
    Stop Timer0                                               'zatrzymaj timer0
    Set Zez_pom                                               'ustaw flage zezwolenia na pomiar
    Br_syg = 0                                                'wyzeruj zmienna br_syg
  End If
Return

Pomiar:                                                       'przerwanie od wejscia int1
  If Zez_pom = 1 Then                                         'jezeli flaga zezwolenia pomiaru ustawiona to
    Counter0 = 0                                              'wyzeruj timer0
    Start Timer0                                              'start timer0
    Reset Zez_pom                                             'wyzeruj flage zezwolenia na pomiar
  Else                                                        'w przeciwnym wypadku
    Stop Timer0                                               'zatrzymaj timer0
    Set Pom_zak                                               'ustaw flage pomiar zakonczony
  End If
  Br_syg = 0
Return

Obs_wysw:                                                     'przerowanie od timer1 obslugujace multipleksowanie wyswietlacza
  If Br_syg <> 65 Then                                        'jezeli br_syg<>65 to
    Incr Br_syg                                               'zwieksz wartosc zmiennej br_syg
  End If
  Counter1 = 61800                                            'wartosc poczatkowa timera1
  Start Timer1
  Set Gr1                                                     'wylacz wszystkie grupy diod led
  Set Gr2
  Set Gr3
  Set Gr4
  Set Gr5
  Select Case Nr_gr_led                                       ' zaleznosci od numeru grupy diod led wykonaj
    Case 1 :
      Call Przel_gr1                                          'wywolaj podprogram obslugi grupy1
      P1 = Gr(1)                                              'wystaw wartosc zmiennej gr(1) na port P1
      Reset Gr1                                               'wlacz grupe 1
    Case 2 :                                                  'dla grupy 2 itd
      Call Przel_gr2
      P1 = Gr(2)
      Reset Gr2
    Case 3 :
      Call Przel_gr3
      P1 = Gr(3)
      Reset Gr3
    Case 4 :
      Call Przel_gr4
      P1 = Gr(4)
      Reset Gr4
    Case 5 :
      Call Przel_gr5
      P1 = Gr(5)
      Reset Gr5
  End Select
  Incr Nr_gr_led                                              'zwieksz zmienna okreslajaca numer grupy
  If Nr_gr_led = 6 Then                                       'jezeli zmienna = 6 to
    Nr_gr_led = 1                                             'zapisz do niej wartosc 1
  End If
Return

Sub Przel_gr1                                                 'podprogram sprawdzajacy warunki zalaczenia diod led grupy 1
  If Wynik >= 1750 Then                                       'jezeli wynik >= od 1750 RPM to zalacz wszystkie LED calej grupy 1
    Gr(1) = 0
    Exit Sub                                                  'wyjdz z podprogramu
  End If
  If Wynik >= 1500 Then                                       'jezeli wynik >= od 1500 RPM to zalacz 7 LED calej grupy 1 itd
    Gr(1) = 128
    Exit Sub
  End If
  If Wynik >= 1250 Then
    Gr(1) = 192
    Exit Sub
  End If
  If Wynik >= 1000 Then
    Gr(1) = 224
    Exit Sub
  End If
  If Wynik >= 750 Then
    Gr(1) = 240
    Exit Sub
  End If
  If Wynik >= 500 Then
    Gr(1) = 248
    Exit Sub
  End If
  If Wynik >= 250 Then
    Gr(1) = 252
    Exit Sub
  End If
  If Wynik < 250 Then
    Gr(1) = 254
  End If
End Sub

Sub Przel_gr2                                                 'podprogram sprawdzajacy warunki zalaczenia diod led grupy 2
  Gr(2) = 255
  If Wynik >= 3750 Then
    Gr(2) = 0
    Exit Sub
  End If
  If Wynik >= 3500 Then
    Gr(2) = 128
    Exit Sub
  End If
  If Wynik >= 3250 Then
    Gr(2) = 192
    Exit Sub
  End If
  If Wynik >= 3000 Then
    Gr(2) = 224
    Exit Sub
  End If
  If Wynik >= 2750 Then
    Gr(2) = 240
    Exit Sub
  End If
  If Wynik >= 2500 Then
    Gr(2) = 248
    Exit Sub
  End If
  If Wynik >= 2250 Then
    Gr(2) = 252
    Exit Sub
  End If
  If Wynik >= 2000 Then
    Gr(2) = 254
  End If
End Sub

Sub Przel_gr3                                                 'podprogram sprawdzajacy warunki zalaczenia diod led grupy 3
  Gr(3) = 255
  If Wynik >= 5750 Then
    Gr(3) = 0
    Exit Sub
  End If
  If Wynik >= 5500 Then
    Gr(3) = 128
    Exit Sub
  End If
  If Wynik >= 5250 Then
    Gr(3) = 192
    Exit Sub
  End If
  If Wynik >= 5000 Then
    Gr(3) = 224
    Exit Sub
  End If
  If Wynik >= 4750 Then
    Gr(3) = 240
    Exit Sub
  End If
  If Wynik >= 4500 Then
    Gr(3) = 248
    Exit Sub
  End If
  If Wynik >= 4250 Then
    Gr(3) = 252
    Exit Sub
  End If
  If Wynik >= 4000 Then
    Gr(3) = 254
  End If
End Sub

Sub Przel_gr4                                                 'podprogram sprawdzajacy warunki zalaczenia diod led grupy 4
  Gr(4) = 255
  If Wynik >= 7750 Then
    Gr(4) = 0
    Exit Sub
  End If
  If Wynik >= 7500 Then
    Gr(4) = 128
    Exit Sub
  End If
  If Wynik >= 7250 Then
    Gr(4) = 192
    Exit Sub
  End If
  If Wynik >= 7000 Then
    Gr(4) = 224
    Exit Sub
  End If
  If Wynik >= 6750 Then
    Gr(4) = 240
    Exit Sub
  End If
  If Wynik >= 6500 Then
    Gr(4) = 248
    Exit Sub
  End If
  If Wynik >= 6250 Then
    Gr(4) = 252
    Exit Sub
  End If
  If Wynik >= 6000 Then
    Gr(4) = 254
  End If
End Sub

Sub Przel_gr5                                                 'podprogram sprawdzajacy warunki zalaczenia diod led grupy 5
  Gr(5) = 255
  If Wynik >= 9000 Then
    Gr(5) = 224
    Exit Sub
  End If
  If Wynik >= 8750 Then
    Gr(5) = 240
    Exit Sub
  End If
  If Wynik >= 8500 Then
    Gr(5) = 248
    Exit Sub
  End If
  If Wynik >= 8250 Then
    Gr(5) = 252
    Exit Sub
  End If
  If Wynik >= 8000 Then
    Gr(5) = 254
  End If
End Sub